struct TexInfo {
	float2 output_size;
};

void main_vertex(
	float4 pos : POSITION,
	float2 uv : TEXCOORD0,
	out float4 oPos : POSITION,
	out float2 oT0 : TEXCOORD0)
{
	oPos = pos;
	oT0 = uv;
}

half4 main_fragment(uniform sampler2D prev_texture, uniform TexInfo PREV, float2 uv : TEXCOORD0) : COLOR0 {
	uv *= PREV.output_size.xy;
	float2 texelCenter = floor(uv + 0.5f);
	float2 texelOffset = texelCenter - uv;
	uv = texelCenter - saturate(texelOffset * 2.0f + 0.5f) + 0.5f;
	uv /= PREV.output_size.xy;

	half4 c = tex2D(prev_texture, uv);
	c.rgb = 1.0h - c.rgb;

	return c;
}
